/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.mde;

import com.jiuqi.mde.MDEDataInfo;
import com.jiuqi.mde.MDEDataInfoSet;
import com.jiuqi.mde.MDEDimension;
import com.jiuqi.mde.MDEDimensionSet;
import com.jiuqi.mde.MDEField;
import com.jiuqi.mde.MDEFieldSet;

public class MDESchema {
    protected String schemaName;
    protected MDEDimensionSet allDimensions = new MDEDimensionSet();
    protected MDEFieldSet allFields = new MDEFieldSet();
    protected MDEDataInfoSet allTableInfos = new MDEDataInfoSet();

    public MDESchema(String name) {
        this.schemaName = name;
    }

    public final String getName() {
        return this.schemaName;
    }

    public final MDEDimension getDimension(String name) {
        MDEDimension result = this.allDimensions.find(name);
        if (result == null) {
            result = this.allDimensions.find(name.toUpperCase());
        }
        return result;
    }

    public final MDEFieldSet fields() {
        return this.allFields;
    }

    public final MDEField getField(String uniqueName) {
        MDEField result = this.allFields.find(uniqueName);
        if (result == null) {
            result = this.allFields.find(uniqueName.toUpperCase());
        }
        return result;
    }

    public final MDEDataInfoSet tableInfos() {
        return this.allTableInfos;
    }

    public final MDEDataInfo getTableInfo(String tableName) {
        MDEDataInfo result = this.allTableInfos.find(tableName);
        if (result == null) {
            result = this.allTableInfos.find(tableName.toUpperCase());
        }
        return result;
    }

    public final MDEDataInfo createTableInfo(String tableName, MDEDimensionSet dimensions) {
        MDEDataInfo result = new MDEDataInfo(tableName);
        result.dimensions().add(dimensions);
        this.allTableInfos.add(result);
        return result;
    }

    public final MDEDataInfo getCalcTableInfoByDimension(MDEDimensionSet dimensions) {
        int i = 0;
        while (i < this.allTableInfos.size()) {
            MDEDataInfo result = this.allTableInfos.get(i);
            if (result.isTemporary() && result.dimensions().equals(dimensions)) {
                return result;
            }
            ++i;
        }
        MDEDataInfo result = new MDEDataInfo("CalcTable " + String.valueOf(this.allTableInfos.size()));
        result.setIsTemporary(true);
        result.dimensions().add(dimensions);
        this.allTableInfos.add(result);
        return result;
    }

    public final MDEDataInfo getFieldTableInfo(String fieldName) {
        MDEField field = this.getField(fieldName);
        if (field == null) {
            return null;
        }
        return this.allTableInfos.find(field.tableName);
    }

    public final MDEDimensionSet getFieldDimensions(String uniqueName) {
        MDEField field = this.getField(uniqueName);
        if (field == null) {
            return null;
        }
        MDEDataInfo result = this.allTableInfos.find(field.tableName);
        if (result != null) {
            return result.dimensions();
        }
        return null;
    }

    public final void compelete() {
        int i = 0;
        while (i < this.allTableInfos.size()) {
            this.allTableInfos.get(i).complete();
            ++i;
        }
    }
}

